// MainFrm.cpp : implmentation of the CMainFrame class
//
/////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "resource.h"

#include "aboutdlg.h"
#include "WinCapView.h"
#include "ChildFrm.h"
#include "MainFrm.h"

#include "Psapi.h"
#pragma comment(lib,"Psapi.lib")

#define TIMEDELAY 1000
#define COMBOBOX_ID	100
LRESULT CClientView::OnPaint(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
{
    CPaintDC dc(m_hWnd);
    if (m_bmSonyCamera)
    {
        RECT rect;
        GetClientRect(&rect);
        int Left = (rect.right - m_size.cx) / 2;
        int Top  = (rect.bottom - m_size.cy) / 2;
        HDC hMemDC = ::CreateCompatibleDC(dc.m_hDC);
        HBITMAP hBmpOld = (HBITMAP) SelectObject(hMemDC,m_bmSonyCamera);
        BitBlt(dc.m_hDC,Left, Top, m_size.cx, m_size.cy, hMemDC, 0, 0, SRCCOPY);
        SelectObject(hMemDC,hBmpOld);
        ::DeleteDC(hMemDC);
    }
    return 0;
}

LRESULT CClientView::OnCreate(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
{
    BITMAP bmInfo;
    m_bmSonyCamera = ::LoadBitmap(_Module.m_hInst,MAKEINTRESOURCE(IDB_SONY));
    ::GetObject(m_bmSonyCamera,sizeof(BITMAP),&bmInfo);
    m_size.cx = bmInfo.bmWidth;
    m_size.cy = bmInfo.bmHeight;
    return 0;
}

LRESULT CClientView::OnSize(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
    RECT rect;
    GetParent().GetClientRect(&rect);
    MoveWindow(&rect);
    return 0;
}

BOOL CMainFrame::PreTranslateMessage(MSG* pMsg)
{
	if(CMDIFrameWindowImpl<CMainFrame>::PreTranslateMessage(pMsg))
		return TRUE;

	HWND hWnd = MDIGetActive();
	if(hWnd != NULL)
		return (BOOL)::SendMessage(hWnd, WM_FORWARDMSG, 0, (LPARAM)pMsg);

	return FALSE;
}

BOOL CMainFrame::OnIdle()
{
	UIUpdateToolBar();
    HWND hWnd = this->MDIGetActive();
    UIEnable(ID_FILE_SAVE, hWnd ? TRUE : FALSE);
    UIEnable(ID_EDIT_COPY, hWnd ? TRUE : FALSE);
    BOOL bResult = EnumDesktopWindows(NULL,(WNDENUMPROC) EnumWindowsProc,(LPARAM) this);
	return FALSE;
}


void CMainFrame::AddToTheList(HWND hWnd)
{
    TCHAR tchCurrentSelected[_MAX_PATH];
    TCHAR tchBuffer[_MAX_PATH];
	TCHAR tchClassName[_MAX_PATH];
    TCHAR tchModuleName[_MAX_PATH];
	HANDLE hProcess;

    ::GetWindowText(hWnd,tchCurrentSelected,_MAX_PATH);

    int nCount = 0;
    bool bChanged = false;
    do
    {
        bChanged = false;
        nCount = SendMessage(m_hWndComboBox, (UINT) CB_GETCOUNT,0,NULL);
        for (int i = 0; i < nCount; i++) 
        {
            HWND hSavedWnd = (HWND) SendMessage(m_hWndComboBox, (UINT) CB_GETITEMDATA,i,NULL);
            if (::IsWindow(hSavedWnd) == FALSE)
            {
               ::SendMessage(m_hWndComboBox,CB_DELETESTRING,i,0);
                bChanged = true;
                map<HWND,WindowInfo>::iterator Pos = m_HanldeList.find(hSavedWnd);
                if (Pos != m_HanldeList.end())
                    m_HanldeList.erase(Pos);
                int nSel = ::SendMessage(m_hWndComboBox,CB_FINDSTRING,-1,(LPARAM) (LPCTSTR)tchCurrentSelected);
                
                int NewSel = (nSel == CB_ERR) ? 0 : nSel;
                SendMessage(m_hWndComboBox, (UINT) CB_SETCURSEL,NewSel,NULL);
                break;
            }
        }
    }while (bChanged);

    if (::IsWindow(hWnd) == FALSE || ::IsWindowVisible(hWnd) == FALSE || ::GetParent(hWnd) || hWnd == m_hWnd)
        return;
	
    ::GetWindowText(hWnd,tchBuffer,_MAX_PATH);
    if (strlen(tchBuffer) == 0)
        return;

    int nResult = ::SendMessage(m_hWndComboBox,CB_FINDSTRING,-1,(LPARAM) (LPCTSTR)tchBuffer);
    if (nResult != CB_ERR)
	{
		for (int i = 0; i < nCount; i++)
		{
			HWND hSavedWnd = (HWND) SendMessage(m_hWndComboBox, (UINT) CB_GETITEMDATA,i,NULL);
			if (hSavedWnd == hWnd)
			   return;
		}
	}
    ::GetClassName(hWnd,tchClassName,_MAX_PATH);
    RECT rect;
    ::GetWindowRect(hWnd,&rect);
    // get pid
	DWORD dwPID;
	GetWindowThreadProcessId(hWnd, &dwPID);
    hProcess = OpenProcess(PROCESS_QUERY_INFORMATION | PROCESS_VM_READ, false, dwPID);
    GetModuleFileNameEx(hProcess, NULL, tchModuleName, _MAX_PATH);
    CloseHandle(hProcess);

    BOOL bDoNoAccept = ::IsWindow(hWnd) == FALSE || ::IsWindowVisible(hWnd) == FALSE || ::GetParent(hWnd) || hWnd == m_hWnd;
        
    if (!bDoNoAccept)
    {
        map<HWND,WindowInfo>::iterator it = m_HanldeList.find(hWnd);
        bool bHidden = (rect.left == rect.right || rect.top == rect.bottom);
        if (it == m_HanldeList.end() && bHidden == false)
        {
            m_HanldeList.insert(std::make_pair(hWnd,WindowInfo(tchBuffer,tchModuleName,dwPID)));
            nResult = ::SendMessage(m_hWndComboBox,CB_ADDSTRING,0,(LPARAM) (LPCTSTR)tchBuffer);
            if (nResult != CB_ERR)
                ::SendMessage(m_hWndComboBox,CB_SETITEMDATA,nResult,(LPARAM) (HWND)hWnd);
     
            nCount = SendMessage(m_hWndComboBox, (UINT) CB_GETCOUNT,0,NULL);
            int CurSel = SendMessage(m_hWndComboBox, (UINT) CB_GETCURSEL,0,NULL);
            if (nCount && CurSel == -1)
                SendMessage(m_hWndComboBox, (UINT) CB_SETCURSEL,0,NULL);
        }
    }

}
BOOL CALLBACK CMainFrame::EnumWindowsProc(HWND hwnd,LPARAM lParam)
{
    CMainFrame* pMainFrame = (CMainFrame*) lParam;
    pMainFrame->AddToTheList(hwnd);
    return true;
}

LRESULT CMainFrame::OnDestroy(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& bHandled)
{
	::SendMessage(m_BackGround,WM_CLOSE,0,0);
	bHandled = FALSE;
	return 0;
}


LRESULT CMainFrame::OnCreate(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
{
	DWORD dwStyle = WS_POPUP | WS_BORDER;
	HWND hBakWnd = m_BackGround.Create(m_hWnd, NULL, NULL,dwStyle);
	::SetWindowPos(m_hWnd,HWND_TOPMOST,0,0,0,0,SWP_NOMOVE | SWP_NOSIZE | SWP_SHOWWINDOW);
	// create command bar window
	HWND hWndCmdBar = m_CmdBar.Create(m_hWnd, rcDefault, NULL, ATL_SIMPLE_CMDBAR_PANE_STYLE);
	// attach menu
	m_CmdBar.AttachMenu(GetMenu());
	// load command bar images
	m_CmdBar.LoadImages(IDR_MAINFRAME);
	// remove old menu
	SetMenu(NULL);

	HWND hWndToolBar = CreateSimpleToolBarCtrl(m_hWnd, IDR_MAINFRAME, FALSE, ATL_SIMPLE_TOOLBAR_PANE_STYLE);

    DWORD dwComboStyle = CBS_DROPDOWNLIST | CBS_SORT | WS_VSCROLL | WS_CHILD | WS_VISIBLE;
    dwComboStyle |= CBS_HASSTRINGS | CBS_OWNERDRAWFIXED;
    m_hWndComboBox = ::CreateWindowEx(0,"COMBOBOX", NULL, dwComboStyle, 20,0,400,20,
				hWndToolBar, (HMENU) COMBOBOX_ID, _Module.m_hInst, NULL);

	m_hFont = CreateFont(
					   -14,                        // nHeight
					   0,                         // nWidth
					   0,                         // nEscapement
					   0,                         // nOrientation
					   FW_BOLD,                 // nWeight
					   FALSE,                     // bItalic
					   FALSE,                     // bUnderline
					   0,                         // cStrikeOut
					   ANSI_CHARSET,              // nCharSet
					   OUT_DEFAULT_PRECIS,        // nOutPrecision
					   CLIP_DEFAULT_PRECIS,       // nClipPrecision
					   DEFAULT_QUALITY,           // nQuality
					   DEFAULT_PITCH | FF_SWISS,  // nPitchAndFamily
					   "Comic Sans MS"); 

	::SendMessage(m_hWndComboBox,(UINT) WM_SETFONT,(WPARAM) m_hFont,TRUE);


	CreateSimpleReBar(ATL_SIMPLE_REBAR_NOBORDER_STYLE);
	AddSimpleReBarBand(hWndCmdBar);
	AddSimpleReBarBand(hWndToolBar, NULL, TRUE);

	CreateSimpleStatusBar();

	CreateMDIClient();
	m_CmdBar.SetMDIClient(m_hWndMDIClient);

	UIAddToolBar(hWndToolBar);
	UISetCheck(ID_VIEW_TOOLBAR, 1);
	UISetCheck(ID_VIEW_STATUS_BAR, 1);

    m_view.Create(m_hWndMDIClient,rcDefault , NULL, WS_CHILD | WS_VISIBLE | WS_CLIPSIBLINGS | WS_CLIPCHILDREN);

	// register object for message filtering and idle updates
	CMessageLoop* pLoop = _Module.GetMessageLoop();
	ATLASSERT(pLoop != NULL);
	pLoop->AddMessageFilter(this);
	pLoop->AddIdleHandler(this);
	BOOL bResult = EnumDesktopWindows(NULL,(WNDENUMPROC) EnumWindowsProc,(LPARAM) this);
	return 0;
}


LRESULT CMainFrame::OnFileExit(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& bHandled)
{
	bHandled = FALSE;

    for (vector<CChildFrame*>::iterator it = m_bmList.begin(); it != m_bmList.end(); it++)
    {
        CChildFrame* pChildFrame = (CChildFrame*) *it;
        int nCloseIt = 0;
        if (pChildFrame && ::IsWindow(pChildFrame->m_hWnd) && pChildFrame->IsSaved() == false)
        {
			nCloseIt = pChildFrame->AskToCloseIt();
			if (nCloseIt == 1)
			{
				::SendMessage(pChildFrame->m_hWnd,WM_CLOSE,1,0);
			}else if (nCloseIt == 0)
			{
               bHandled = TRUE;
               return 0;
			}            
        }
    }
    PostMessage(WM_CLOSE);
	return 0;
}

LRESULT CMainFrame::OnFileNew(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
{

    TCHAR NameString[_MAX_PATH];
    HWND hSelectWnd = BringToTheTop();

    ::GetWindowText(hSelectWnd,NameString,_MAX_PATH);

	CChildFrame* pChild = new CChildFrame;
    m_bmList.push_back(pChild);
    ShowWindow(SW_HIDE);
    Sleep(100);

	pChild->CreateEx(m_hWndClient);
    pChild->BuildBitmap(hSelectWnd,NameString);
    ShowWindow(SW_SHOWNORMAL);
    SetForegroundWindow(m_hWnd);
	return 0;
}

 HWND CMainFrame::BringToTheTop()
 {
   int CurSel = SendMessage(m_hWndComboBox, (UINT) CB_GETCURSEL,0,NULL);
   HWND hSavedWnd = (HWND) SendMessage(m_hWndComboBox, (UINT) CB_GETITEMDATA,CurSel,NULL);

   ::ShowWindow(hSavedWnd,SW_SHOWNORMAL);
   ::SetForegroundWindow(hSavedWnd);
   return hSavedWnd;
 }

LRESULT CMainFrame::OnRefresh(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
{
	HWND hSavedWnd = BringToTheTop();
	Sleep(5);
    RECT rectFrom;
	::GetWindowRect(hSavedWnd,&rectFrom);
//  RECT rectTo;
//	::SetRect(&rectTo,rectFrom.left,rectFrom.top,rectFrom.right,rectFrom.bottom);
//	::InflateRect(&rectTo,-100,-100);
//	::DrawAnimatedRects(hSavedWnd, IDANI_CAPTION, &rectFrom, &rectTo);

    WindowInfo WInfo = m_HanldeList[hSavedWnd];

    if (_stricmp(_T("Program Manager"),WInfo.m_strWindowTitle))
	   ::InflateRect(&rectFrom,8,8);

	int nWidth  = rectFrom.right - rectFrom.left;
	int nHeight = rectFrom.bottom - rectFrom.top;

	::SetWindowPos(m_BackGround,HWND_BOTTOM,rectFrom.left,rectFrom.top,nWidth,nHeight,SWP_SHOWWINDOW);
	Sleep(2000);
	::SetWindowPos(m_BackGround,HWND_TOP,rectFrom.left,rectFrom.top,nWidth,nHeight,SWP_HIDEWINDOW);
	return 0;
}


LRESULT CMainFrame::OnAppAbout(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
{
	CAboutDlg dlg;
	dlg.DoModal();
	return 0;
}

LRESULT CMainFrame::OnWindowCascade(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
{
	MDICascade();
	return 0;
}

LRESULT CMainFrame::OnWindowTile(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
{
	MDITile();
	return 0;
}

LRESULT CMainFrame::OnWindowArrangeIcons(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
{
	MDIIconArrange();
	return 0;
}

LRESULT CMainFrame::OnSize(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
    bHandled = FALSE;
   ::PostMessage(m_view,WM_SIZE,wParam,lParam);
    return 0;
}

CMainFrame::~CMainFrame()
{
	::DeleteObject(m_hFont);
	m_HanldeList.clear();
	m_bmList.clear();
}


LRESULT CMainFrame::OnDrawItem(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
    LPDRAWITEMSTRUCT lpDrawItemStruct = (LPDRAWITEMSTRUCT) lParam;
	
    if (wParam == COMBOBOX_ID)
	{
        HRESULT hr = S_OK;
        RECT item_rect;
        HDC hDC = 0;
        HICON hIconLarge, hIconSmall;
        HWND hCurWnd = (HWND) lpDrawItemStruct->itemData;
        WindowInfo info = m_HanldeList[hCurWnd];
        ExtractIconEx(info.m_strModuleName, 0, &hIconLarge, &hIconSmall, 1);
        ICONINFO oIconInfo;
        GetIconInfo(hIconSmall, &oIconInfo);

        item_rect = lpDrawItemStruct->rcItem;
        hDC = lpDrawItemStruct->hDC;
        int OldMode = SetBkMode(hDC,TRANSPARENT);

        TCHAR tchBuffer[_MAX_PATH];
        memset(tchBuffer,0,_MAX_PATH);
        int nResult = ::SendMessage(m_hWndComboBox,CB_GETLBTEXT,lpDrawItemStruct->itemID,(LPARAM) (LPCTSTR)tchBuffer);

        DWORD dwStyle = DT_LEFT | DT_END_ELLIPSIS | DT_VCENTER | DT_SINGLELINE | DT_NOPREFIX;
    
        int Height = item_rect.bottom - item_rect.top;
        COLORREF ItemColor;
        if(lpDrawItemStruct->itemState & ODS_SELECTED)
        {
           ItemColor = GetSysColor(COLOR_HIGHLIGHT);
           SetTextColor(hDC,GetSysColor(COLOR_HIGHLIGHTTEXT));
        }
        else
        {
            ItemColor = GetSysColor(COLOR_WINDOW);
            SetTextColor(hDC,GetSysColor(COLOR_BTNTEXT));
        }

        HPEN square_pen = CreatePen(PS_SOLID, 1, ItemColor);
        HBRUSH squares_brush = CreateSolidBrush(ItemColor);
        SelectObject(hDC, square_pen);
        SelectObject(hDC, squares_brush);
       
        Rectangle(hDC, item_rect.left, item_rect.top,item_rect.right, item_rect.bottom);
        DrawIconEx(hDC,item_rect.left + 2,item_rect.top + 2,hIconLarge,16,16,0,NULL,DI_NORMAL);

        DeleteObject(square_pen);
        DeleteObject(squares_brush);

        item_rect.left += Height + 4;
        DrawText(hDC, (LPCSTR) tchBuffer, (int) strlen(tchBuffer), &item_rect,dwStyle);
        SetBkMode(hDC,OldMode);

	}
	return 0;
}

LRESULT CMainFrame::OnFileSave(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& bHandled)
{
    bHandled = FALSE;
    HWND hWnd = this->MDIGetActive();

    for (vector<CChildFrame*>::iterator it = m_bmList.begin(); it != m_bmList.end(); it++)
    {
        CChildFrame* pChildFrame = (CChildFrame*) *it;
        if (pChildFrame->m_hWnd == hWnd)
        {
            pChildFrame->SavedIt();
            break;
        }        
    }
    return 0;
}

LRESULT CMainFrame::OnClose(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
    bHandled = FALSE;

    for (vector<CChildFrame*>::iterator it = m_bmList.begin(); it != m_bmList.end(); it++)
    {
        CChildFrame* pChildFrame = (CChildFrame*) *it;
        int nCloseIt = 0;
        if (pChildFrame && ::IsWindow(pChildFrame->m_hWnd) && pChildFrame->IsSaved() == false)
        {
			nCloseIt = pChildFrame->AskToCloseIt();
			if (nCloseIt == 1)
			{
				::SendMessage(pChildFrame->m_hWnd,WM_CLOSE,1,0);
			}else if (nCloseIt == 0)
			{
               bHandled = TRUE;
               return 0;
			}            
        }
    }
    return 0;
}

LRESULT CMainFrame::OnEditCopy(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
{
    HWND hWnd = this->MDIGetActive();

    for (vector<CChildFrame*>::iterator it = m_bmList.begin(); it != m_bmList.end(); it++)
    {
        CChildFrame* pChildFrame = (CChildFrame*) *it;
        if (pChildFrame->m_hWnd == hWnd)
        {
            pChildFrame->OnEditCopy();
            break;
        }        
    }
    return 0;
}


